DCMTK - Patch #507

Diverse Bugfixes von Per Inge Mathisen
2013-03-05 09:42 - Marco Eichelberg

Status: Closed Start date: 2013-03-05
Priority: High Due date:

Assignee: % Done: 90%
Category: Library Estimated time: 0:00 hour
Target version: 3.6.2

Module: Compiler:

Operating System:

Description

The attached patch fixes various issues found by running latest version
of cppcheck over demtk git master. Note that | have not tested these
changes, apart from running them through you unit tests

Concerning the last change - it is apparently a very bad idea to throw
an exception from a destructor, and cppcheck considers it an error.

More fixes after running static analysis on your software.

ofstringoffbyone.diff - fixes a few off-by-one errors in your fallback
implementation of std::string. After skimming through that code, | think
| would recommend that you retire it and rely on working std::string
implementations instead.

misc.diff - various places where pointers could be dereferenced while
NULL

History

#1 - 2013-03-05 09:49 - Marco Eichelberg
- Tracker changed from Bug to Patch

#2 - 2013-03-05 09:53 - J6rg Riesmeier
- Category set to Library

- Target version set to 3.6.2

#3 - 2013-03-05 09:53 - Jorg Riesmeier
- Priority changed from Normal to High

#4 - 2013-03-08 18:50 - Jorg Riesmeier

- Assignee set to Uli Schlachter

#5 - 2013-03-11 12:16 - Uli Schlachter
- Status changed from New to Feedback
- Assignee deleted (Uli Schlachter)

- % Done changed from 0 to 90

ofstringoffbyone.diff: NAK, reserve(n) makes sure there is an array of size at least (n+1), so this already makes sure that there is space for the EOS
mark (and AFAIR this is the behavior that the C++ standard requires).

misc.diff: | don't like the "else {" >—"else-i-{ast-{-change—Fhis-cannevermake-a-difference; becauselast—and—handle—>findRequestList" are both

set in the same line. If this ever happens (remember, it cannot happen), a crash is IMHO better than silently forgetting (and leaking) parts of the
request and generating a wrong reply. No one wants to debug that.

The "throw exception from destructor"-problem is reported to log4cplus.
All the other changes are part of commit a5fdfd28ccd1f067676abd6cebb70cac911709b0.

Someone should write a "thank you" mail with the above comments and a link to the commit in gitweb to Per...

#6 - 2013-03-11 14:56 - Uli Schlachter

Half of the change to oflog was applied to log4cplus: https://sourceforge.net/p/log4cplus/bugs/162/

#7 - 2013-07-04 17:56 - Michael Onken

Wrote that thank you email :)

#8 - 2013-07-04 17:57 - Michael Onken
- Status changed from Feedback to Closed

Files

cppcheckfixes.diff 4.88 KB 2013-03-05 Marco Eichelberg
misc.diff 1.8 KB 2013-03-05 Marco Eichelberg
ofstringoffbyone.diff 1.07 KB 2013-03-05 Marco Eichelberg
